{ Diese Unit ermglicht es, laufende Prozesse - insbesondere aktivierte Proze- }
{ duren - soweit in ihrer Abarbeitung zu unterbrechen, dass erst nach einer    }
{ erfolgten Aktion auf der DELPHI-Oberflche die Abarbeitung der aktivierten   }
{ Routine fortgesetzt wird.                                                    }
{ Genutzt wird dazu die Methode "ProcessMessages" von "Application".           }
{                                                                              }
{ Application ist eine "Anwendungskomponente" von DELPHI. Jedes Projekt unter  }
{ DELPHI wird einer Variablen vom Typ TApplication zugeordnet. Insbesondere    }
{ bedeutet die Ausfhrung eines DELPHI-Projekts eigentlich nichts anderes als  }
{ den Start einer oberflchenorientierten Ereignisschleife, die nacheinander   }
{ alle Oberflchenobjekte auf die Aktivierung irgendwelcher Oberflchenereig-  }
{ nisse abfragt und gegebenenfalls diese Ereignisse ausfhrt.                  }
{                                                                              }
{ In interaktiven Routinen muss nun genau eine solche Routine auf Eingaben des }
{ Users mittels der Oberflche warten - ihre Abarbeitung also unterbrochen     }
{ werden. Dies kann dadurch erreicht werden, dass eine knstliche ProcessMes-  }
{ sages-Schleife aufgerufen wird --> Procedure warte ! Diese Schleife gibt die }
{ Programmsteuerung wieder an die Oberflche ab. Erst von dort - durch Manipu- }
{ lation der zwei im Implementation-Teil bereitgestellten, dadurch aber nach   }
{ auen abgeschirmten globalen Flagvariablen                                   }
{                                                                              }
{            'interaktion_erfolgt_' und 'schluss_gesetzt_'                     }
{                                                                              }
{ ber die Operationen                                                         }
{                                                                              }
{                    'mach_weiter' und 'hoer_auf'                              }
{                                                                              }
{ kann diese Schleife abgebrochen werden, sodass die Programmausfhrung an der }
{ Stelle in der vorher aktiven Routine fortgesetzt wird.                       }
{                                                                              }
{ Der Unterschied in den beiden genannten Operationen besteht darin, dass die  }
{ erstgenannte 'mach_weiter' beim nchsten 'warte' wiederum die Steuerung an   }
{ die DELPHI-Oberflche bergibt, die zweite 'hoer_auf' allerdings ein 'warte' }
{ ignoriert. Diese zweite Operation wird bentigt, falls z.B. bei einem Back-  }
{ tracking-Demo keine Zwischenschritte mehr angezeigt werden sollen.           }
{                                                                              }
{ ber die Operation     'fang_wieder_an'     kann ein hoer_auf wieder rck-   }
{ gngig gemacht werden, falls man einen neuen Durchlauf im Einzelschritt      }
{ starten mchte.                                                              }
{ --------------V 2.0/29.10.99 / EMA Bonn / Link - gendert 31.08.00 / Garmann }


unit interakt;

interface

  uses forms;         {wegen der Manipulation von Application.ProcessMessages}

  procedure init_Interaktion;
  procedure warte;
  procedure mach_weiter;
  procedure hoer_auf;
  procedure fang_wieder_an;

implementation

  var interaktion_erfolgt_,                          {globale Steuerungsflags}
      schluss_gesetzt_: Boolean;

  procedure init_Interaktion;
  begin
    interaktion_erfolgt_ := False;
    schluss_gesetzt_     := False;
  end;

  procedure warte;
  begin
    repeat
      Application.ProcessMessages
    until interaktion_erfolgt_ or schluss_gesetzt_;
    interaktion_erfolgt_ := False
  end;

  procedure mach_weiter;
  begin
    interaktion_erfolgt_:= True
  end;

  procedure hoer_auf;
  begin
    schluss_gesetzt_:= True
  end;

  procedure fang_wieder_an;
  begin
    schluss_gesetzt_:= false;
  end;

Initialization
  init_Interaktion;
end.
