unit U_spiel;

interface

uses ExtCtrls, SysUtils, Dialogs, Graphics, Classes, interakt;

type
     TIndex = 0..2;
     TZug = record
                x,y: TIndex;
            end;
     TSpieler = (Computer, Mensch, Keiner);
     TPosition = record
       feld: array[0..2,0..2] of TSpieler;
       amZug: TSpieler;
     end;

     TSpiel = class
       PB: TPaintbox;
       Position: TPosition;
       constructor create(amZug: TSpieler; Ausgabe: TPaintbox);
       function zulaessig(Position: TPosition; Zug: TZug): boolean;
       procedure ausfuehren(Position: TPosition; Zug: TZug; var neuPosition: TPosition);
       function amEnde(Position: TPosition): boolean;
       procedure Ausgabe;
       function Spielerzug: TZug;
       function Computerzug: TZug;
       procedure Starten;
     end;

var x,y: integer;    { Zur bergabe der Mausposition }

implementation


{ Methode der Klasse TSpiel }

constructor TSpiel.create(amZug: TSpieler; Ausgabe: TPaintbox);
var x,y: TIndex;
begin
  PB:= Ausgabe;
  Position.amZug:= amZug;
  for x:= 0 to 2
  do for y:= 0 to 2
     do Position.feld[x,y]:= Keiner;
end;

function TSpiel.zulaessig(Position: TPosition; Zug: TZug): boolean;
begin
  zulaessig:= (Position.Feld[Zug.x,Zug.y]=Keiner);
end;

procedure TSpiel.ausfuehren(Position: TPosition; Zug: TZug; var neuPosition: TPosition);
begin
  neuPosition.Feld:= Position.Feld;
  neuPosition.Feld[Zug.x,Zug.y]:= Position.amZug;
  if Position.amZug = Computer
    then neuPosition.amZug:= Mensch
    else neuPosition.amZug:= Computer;
end;

function TSpiel.amEnde(Position: TPosition): boolean;
var x,y: TIndex;
    voll, reihe: boolean;
begin
  voll:= true;
  for x:= 0 to 2
  do for y:= 0 to 2
     do if Position.Feld[x,y]=Keiner
        then voll:= false;
  reihe:= false;
  for x:= 0 to 2
  do reihe:= reihe or ((Position.feld[x,0]=Position.feld[x,1]) and (Position.feld[x,1]=Position.feld[x,2]) and (Position.feld[x,0]<>Keiner));
  for y:= 0 to 2
  do reihe:= reihe or ((Position.feld[0,y]=Position.feld[1,y]) and (Position.feld[1,y]=Position.feld[2,y]) and (Position.feld[0,y]<>Keiner));
  reihe:= reihe or ((Position.feld[0,0]=Position.feld[1,1]) and (Position.feld[1,1]=Position.feld[2,2]) and (Position.feld[1,1]<>Keiner));
  reihe:= reihe or ((Position.feld[2,0]=Position.feld[1,1]) and (Position.feld[1,1]=Position.feld[0,2]) and (Position.feld[1,1]<>Keiner));
  amEnde:= voll or reihe;
end;

procedure TSpiel.Ausgabe;
var x,y: TIndex;
    i: integer;
begin
  PB.Refresh;
  if Position.amZug = Mensch
    then PB.Canvas.Textout(10,70,'am Zug: Spieler')
    else PB.Canvas.Textout(10,70,'am Zug: Computer');
  for x:= 0 to 2
  do begin
       for y:= 0 to 2
       do begin
            case Position.feld[x,y] of
              Mensch:   begin
                          PB.Canvas.Brush.Color:= clRed;
                          PB.Canvas.Brush.Style:= bsSolid;
                        end;
              Computer: begin
                          PB.Canvas.Brush.Color:= clBlue;
                          PB.Canvas.Brush.Style:= bsSolid;
                        end;
              Keiner:   begin
                          PB.Canvas.Brush.Style:= bsClear;
                        end;
            end;
            PB.Canvas.FillRect(rect(x*20,y*20,(x+1)*20,(y+1)*20));
          end;
     end;
  for i:= 0 to 3
  do begin
       PB.Canvas.MoveTo(i*20,0);
       PB.Canvas.LineTo(i*20,60);
       PB.Canvas.MoveTo(0,i*20);
       PB.Canvas.LineTo(60,i*20);
     end;
end;

function TSpiel.Spielerzug: TZug;
var Eingabe: string;
    zug: TZug;
begin
  repeat
    warte;
    Zug.x:= x;
    Zug.y:= y;
  until zulaessig(Position,zug);
  Spielerzug:= Zug;
end;

function TSpiel.Computerzug: TZug;
var besterZug, Verlegenheitszug: TZug;
    besterWert: integer;
    Zug: TZug;

  function Endwert(Position: TPosition): integer;
  var x,y: TIndex;
      reihe: boolean;
  begin
    reihe:= false;
    for x:= 0 to 2
    do reihe:= reihe or ((Position.feld[x,0]=Position.feld[x,1]) and (Position.feld[x,1]=Position.feld[x,2]) and (Position.feld[x,0]<>Keiner));
    for y:= 0 to 2
    do reihe:= reihe or ((Position.feld[0,y]=Position.feld[1,y]) and (Position.feld[1,y]=Position.feld[2,y]) and (Position.feld[0,y]<>Keiner));
    reihe:= reihe or ((Position.feld[0,0]=Position.feld[1,1]) and (Position.feld[1,1]=Position.feld[2,2]) and (Position.feld[1,1]<>Keiner));
    reihe:= reihe or ((Position.feld[2,0]=Position.feld[1,1]) and (Position.feld[1,1]=Position.feld[0,2]) and (Position.feld[1,1]<>Keiner));

    if reihe
    then Endwert:= 1
    else Endwert:= 0;
  end;

  function negmax(Position: TPosition; var besterZug: TZug): integer;
  var Wert, NachfolgerWert: integer;
      Probezug, Zug: TZug;
      Nachfolger: TPosition;
      x,y: TIndex;
  begin
    if amEnde(Position)
    then negmax:= -Endwert(Position)
    else begin
           Wert:= -2;
           for x:= 0 to 2
           do for y:= 0 to 2
               do begin
                    Probezug.x:= x;
                    Probezug.y:= y;
                    if zulaessig(Position,Probezug)
                    then begin
                           ausfuehren(Position,Probezug,Nachfolger);
                           Nachfolgerwert:= -negmax(Nachfolger,Zug);
                           if (NachfolgerWert > Wert) or
                              ((NachfolgerWert = Wert) and (Probezug.x=1) and (Probezug.y=1))
                           then begin
                                  Wert:= NachfolgerWert;
                                  besterZug:= Probezug;
                                end
                         end;
                  end;
           negmax:= Wert;
         end;
  end;

begin
  besterWert:= negmax(Position,besterZug);
  if besterWert >= 0
  then Zug:= besterZug
  else begin
          Repeat
             Verlegenheitszug.x:= random(3);
             Verlegenheitszug.y:= random(3);
          Until zulaessig(Position,Verlegenheitszug);
          Zug:= Verlegenheitszug;
       end;
   ComputerZug:= Zug;
end;

procedure TSpiel.Starten;
var Zug: TZug;
begin
  while not amEnde(Position)
  do begin
       if Position.amZug = Mensch
         then Zug:= Spielerzug
         else Zug:= Computerzug;
       ausfuehren(Position,Zug,Position);
       Ausgabe;
     end;
end;

end.
